local E, L, V, P, G, _ = unpack(ElvUI); --Import: Engine, Locales, PrivateDB, ProfileDB, GlobalDB

-- an OO table to handle the Glowing of the ElvUI party/raid frames
----------------------------------------- GLOW -----------------------------------------------------
Glow = 
{
	Min = 0.2,
	Max = 0.8,
	Value = 0.8,
	Increment = 0.1,
	Direction = 1.0,
	FrameTarget = nil, -- this gets set to the party/raid frame to glow
	GlowTime = 50.0,
};

function Glow:New()
	newGlow = {};
	setmetatable(newGlow, self)
	self.__index = self
	return newGlow
end

function Glow:UpdateGlow(deltaTime)
	-- update the glow alpha
	self.Value = self.Value + (self.Increment * self.Direction);
	if self.Value > self.Max then
		self.Value = self.Max;
		self.Direction = -1.0;
	end
	
	if self.Value < self.Min then
		self.Value = self.Min;
		self.Direction = 1.0;
	end
	-- update the remaining time
	self.GlowTime = self.GlowTime - deltaTime;
	
	frameColor = E.private.SaveMe.Glow.frameColor;
	self.FrameTarget.SaveMeGlow:SetVertexColor(frameColor.r, frameColor.g, frameColor.b, frameColor.a * self.Value)
end

function Glow:StartGlow()
	-- ensure the frame has the SaveMe layer
	if not self.FrameTarget.SaveMeGlow then
		self.FrameTarget.SaveMeGlow = self.FrameTarget:CreateTexture(nil, "OVERLAY");
		self.FrameTarget.SaveMeGlow:SetInside(self.FrameTarget.Health.backdrop);
		self.FrameTarget.SaveMeGlow:SetTexture(E['media'].blankTex)
		self.FrameTarget.SaveMeGlow:SetBlendMode("BLEND")
	end
	
	-- set from the options
	self.Min = E.private.SaveMe.Glow.alphaMin;
	self.Max = E.private.SaveMe.Glow.alphaMax;
	self.Increment = E.private.SaveMe.Glow.alphaIncrement;
	self.GlowTime = E.private.SaveMe.Glow.glowTime;
	self.Value = self.Min;	
	
	-- show
	frameColor = E.private.SaveMe.Glow.frameColor;
	self.FrameTarget.SaveMeGlow:Show();
	self.FrameTarget.SaveMeGlow:SetVertexColor(frameColor.r, frameColor.g, frameColor.b, frameColor.a)
	
end

function Glow:StopGlow()
	self.FrameTarget.SaveMeGlow:Hide();
end
----------------------------------------------------------------------------------------------------
