local E, L, V, P, G = unpack(ElvUI); --Import: Engine, Locales, PrivateDB, ProfileDB, GlobalDB, Localize Underscore
local SaveMeOptions = E:NewModule('SaveMeOptions', 'AceEvent-3.0')
local EP = LibStub('LibElvUIPlugin-1.0')
local ElvUISaveMeOptions = select(1, ...)

function SaveMeOptions:GetOptions()
	local SaveMeLocal = E:GetModule('SaveMe')

	E.Options.args.SaveMe = {
		type = 'group',
		name = L["SAVEME_TITLE"],
		get = function(info) return E.private.SaveMe [ info[#info] ] end,
		set = function(info, value) E.private.SaveMe [ info[#info] ] = value end,
		args = {
			intro = 
			{
				order = 1,
				type = 'description',
				name = L["SAVEME_DESC"],
			},
			enabled = 
			{
				order = 2,
				type = 'toggle',
				name = L['Enable'],
				desc = L["SAVEME_ENABLE_DESC"],
				set = function(info, value) E.private.SaveMe.enabled = value SaveMeLocal:ToggleEnabled(value) end
			},
			debugPrint = 
			{
				order = 3,
				type = 'toggle',
				name = "Show Debug",
				desc = "Show Debug",
			},
			pingSelf = 
			{
				order = 4,
				type = 'toggle',
				name = L['SAVEME_PINGSELF_NAME'],
				desc = L["SAVEME_PINGSELF_DESC"],
				set = function(info, value) E.private.SaveMe.pingSelf = value SaveMeLocal:TogglePingSelf(value) end
			},
			Glow = 
			{
				order = 5,
				type = "group",
				name = L["SAVEME_GLOWGROUP_NAME"],
				guiInline = true,
				args = 
				{
					frameColor = 
					{
						order = 1,
						type = 'color',
						name = L["SAVEME_UNITCOLOR_NAME"],
						desc = L["SAVEME_UNITCOLOR_DESC"],
						hasAlpha = true,
						
						get = function(info)
							local temp = E.private.SaveMe.Glow.frameColor
							return temp.r, temp.g, temp.b, temp.a
						end,
						set = function(info, r, g, b, a)
							E.private.SaveMe.Glow.frameColor.r, E.private.SaveMe.Glow.frameColor.g, E.private.SaveMe.Glow.frameColor.b, E.private.SaveMe.Glow.frameColor.a = r, g, b, a
						end
					},
					alphaMin = 
					{
						order = 2,
						type = "range",
						isPercent = false,
						name = L["SAVEME_ALPHAMIN_NAME"],
						desc = L["SAVEME_ALPHAMIN_DESC"],
						min = 0,
						max = 1,
						step = 0.05,
						
						get = function(info)
							return E.private.SaveMe.Glow.alphaMin;
						end,
						set = function(info, value)
							E.private.SaveMe.Glow.alphaMin = value;
						end
					},
					alphaMax = 
					{
						order = 3,
						type = "range",
						isPercent = false,
						name = L["SAVEME_ALPHAMAX_NAME"],
						desc = L["SAVEME_ALPHAMAX_DESC"],
						min = 0,
						max = 1,
						step = 0.05,
						
						get = function(info)
							return E.private.SaveMe.Glow.alphaMax;
						end,
						set = function(info, value)
							E.private.SaveMe.Glow.alphaMax = value;
						end
					},
					alphaIncrement = 
					{
						order = 4,
						type = "range",
						isPercent = false,
						name = L["SAVEME_ALPHAINCREMENT_NAME"],
						desc = L["SAVEME_ALPHAINCREMENT_DESC"],
						min = 0.01,
						max = 1,
						step = 0.01,
						
						get = function(info)
							return E.private.SaveMe.Glow.alphaIncrement;
						end,
						set = function(info, value)
							E.private.SaveMe.Glow.alphaIncrement = value;
						end
					},
					glowTime = 
					{
						order = 5,
						type = "range",
						isPercent = false,
						name = L["SAVEME_GLOWTIME_NAME"],
						desc = L["SAVEME_GLOWTIME_DESC"],
						min = 0.5,
						max = 10,
						step = 0.1,
						
						get = function(info)
							return E.private.SaveMe.Glow.glowTime;
						end,
						set = function(info, value)
							E.private.SaveMe.Glow.glowTime = value;
						end
					},
				},
			},
		},
	}
end
--[[

					enabled = 
					{
						order = 2,
						type = 'toggle',
						name = L['Enable'],
						desc = L["SAVEME_ENABLE_DESC"],
						set = function(info, value) E.private.SaveMe.enabled = value SaveMeLocal:ToggleEnabled(value) end
					},

]]--
function SaveMeOptions:Initialize()
	EP:RegisterPlugin(ElvUISaveMeOptions, SaveMeOptions.GetOptions)
end

E:RegisterModule(SaveMeOptions:GetName())